﻿using System;
using System.Threading.Tasks;

namespace P31NMAUIDemo
{
	public class Utility
	{
		public Utility()
		{
		}

        #region "Toast"
        public static void ShowToastMessage(BaseViewModel vm, string message)
        {
            if (vm != null)
            {
                vm.ShowActivityIndicator = false;
                vm.ShowMask = true;
                vm.ShowToast = true;
                vm.ToastMessage = message;
                //Debug.WriteLine(DateTime.Now.ToString("HH:mm:ss") + " " + message);
                //if (toastMessageType == ToastMessageType.SUCCESS) vm.ToastIcon = ImageSource.FromResource("AsTimeNew.Icons.success.png");
                //else if (toastMessageType == ToastMessageType.FAILURE) vm.ToastIcon = ImageSource.FromResource("AsTimeNew.Icons.fail.png");
                Task.Run(async () =>
                {
                    await Task.Delay(2000);
                    vm.ShowToast = false;
                    vm.ShowMask = false;
                    vm.ToastMessage = "";
                });
            }
        }
        #endregion

        #region "ActivityIndicator"
        public static void LoadActivityIndicator(BaseViewModel vm, bool isLoading, string message = "")
        {
            vm.ShowToast = false;
            vm.ShowActivityIndicator = isLoading;//两个种类的indicator，这个变量代表显示1种类的
            vm.ActivityIndicatorIsRunning = isLoading;
            vm.ShowMask = isLoading;
            vm.ActivityIndicatorText = message;
        }
        #endregion

        static string GetPreferencesData(string key)
        {
            return Preferences.Get(key, "");
        }

        public static List<bool> GetInventoryAnts()
        {
            List<bool>? list = new List<bool>();
            string text = GetPreferencesData("INVENTORY_ANTS");
            if (!string.IsNullOrEmpty(text))
            {
                list = Newtonsoft.Json.JsonConvert.DeserializeObject<List<bool>?>(text);
            }
            return list;
        }

        public static void SetInventoryAnts(List<bool> ants)
        {
            string jsonStr = Newtonsoft.Json.JsonConvert.SerializeObject(ants);
            Preferences.Set("INVENTORY_ANTS", jsonStr);
        }
    }
}

