﻿using System;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace P31NMAUIDemo
{
	public class MainPageViewModel : BaseViewModel
	{
		public MainPageViewModel()
		{
        }

        ObservableCollection<string> ipList = new ObservableCollection<string>();
        public ObservableCollection<string> IPList
        {
            get { return ipList; }
            set
            {
                if (ipList == value) return;
                ipList = value;
                OnPropertyChanged("IPList");
            }
        }

        ObservableCollection<Tag> tags = new ObservableCollection<Tag>();
        public ObservableCollection<Tag> Tags
        {
            get { return tags; }
            set
            {
                if (tags == value) return;
                tags = value;
                OnPropertyChanged("Tags");
            }
        }

        string selectedIP = "Disconnected";
        public string SelectedIP
        {
            get { return selectedIP; }
            set
            {
                if (selectedIP == value) return;
                selectedIP = value;
                OnPropertyChanged("SelectedIP");
            }
        }

        bool showLabelTags = false;
        public bool ShowLabelTags
        {
            get { return showLabelTags; }
            set
            {
                if (showLabelTags == value) return;
                showLabelTags = value;
                OnPropertyChanged("ShowLabelTags");
            }
        }

        bool showIPList = false;
        public bool ShowIPList
        {
            get { return showIPList; }
            set
            {
                if (showIPList == value) return;
                showIPList = value;
                OnPropertyChanged("ShowIPList");
            }
        }

        int totalTags = 0;
        public int TotalTags
        {
            get { return totalTags; }
            set
            {
                if (totalTags == value) return;
                totalTags = value;
                OnPropertyChanged("TotalTags");
            }
        }

        bool isConnected = false;
        public bool IsConnected
        {
            get { return isConnected; }
            set
            {
                if (isConnected == value) return;
                isConnected = value;
                OnPropertyChanged("IsConnected");
            }
        }

        bool antEnabled = true;
        public bool AntIsEnabled
        {
            get { return antEnabled; }
            set
            {
                if (antEnabled == value) return;
                antEnabled = value;
                OnPropertyChanged("AntIsEnabled");
            }
        }

        Color antCheckBoxColor = Color.FromArgb("#007aff");
        public Color AntCheckBoxColor
        {
            get { return antCheckBoxColor; }
            set
            {
                if (antCheckBoxColor == value) return;
                antCheckBoxColor = value;
                OnPropertyChanged("AntCheckBoxColor");
            }
        }
    }

    public class Tag : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler? PropertyChanged;

        string _epc;
        public string EPC { get { return _epc; } }

        int _ant;
        public int Ant
        {
            get { return _ant; }
            set
            {
                if (_ant == value) return;
                _ant = value;
                PropertyChanged?.Invoke(this, new PropertyChangedEventArgs("Ant"));
            }
        }

        int count = 1;
        public int Count
        {
            get { return count; }
            set
            {
                if (count == value) return;
                count = value;
                PropertyChanged?.Invoke(this, new PropertyChangedEventArgs("Count"));
            }
        }

        public Tag(string epc, int ant)
        {
            _epc = epc;
            _ant = ant;
        }
    }
}

